Index: /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/test_gauge.py
===================================================================
--- /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/test_gauge.py	(revision 8203)
+++ /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/test_gauge.py	(revision 8204)
@@ -464,5 +464,5 @@
         """
         This is testing the sww2csv_gauges function, by creating a multiple 
-        sww file and then exporting the gauges and checking the results.
+        sww files and then exporting the gauges and checking the results.
         """
         timestep=2.0
Index: /trunk/anuga_validation/validation_tests/circular_dam_break.py
===================================================================
--- /trunk/anuga_validation/validation_tests/circular_dam_break.py	(revision 8203)
+++ /trunk/anuga_validation/validation_tests/circular_dam_break.py	(revision 8204)
@@ -103,5 +103,5 @@
 #------------------------------------------------------------------------------
 
-for t in domain.evolve(yieldstep = 0.1, finaltime = 6.0):
+for t in domain.evolve(yieldstep = 0.1, finaltime = 20.0):
     #print domain.timestepping_statistics(track_speeds=True)
     print domain.timestepping_statistics()
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/channel/channel_flow_2_padarn.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/channel/channel_flow_2_padarn.py	(revision 8203)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/channel/channel_flow_2_padarn.py	(revision 8204)
@@ -1,7 +1,10 @@
 import os
 from math import sqrt, pow, pi 
-from channel_domain import *
-from Numeric import allclose, array, zeros, ones, Float, take, sqrt
-from config import g, epsilon
+
+import numpy as np
+
+from anuga_1d.channel.channel_domain import *
+from anuga_1d.config import g, epsilon
+from anuga_1d.base.generic_mesh import uniform_mesh
 
 
@@ -19,5 +22,5 @@
 
 def bed(x):
-    y = zeros(len(x),Float)
+    y = np.zeros(len(x),np.float)
     for i in range(len(x)):
         if x[i]<525 and x[i]>475:
@@ -46,5 +49,5 @@
 print "Evaluating domain with %d cells" %N
 cell_len = L/N # Origin = 0.0
-points = zeros(N+1,Float)
+points = np.zeros(N+1,np.float)
 
 # Define the centroid points
@@ -62,5 +65,6 @@
 
 # Set boundry type, order, timestepping method and limiter
-domain.set_boundary({'exterior': Dirichlet_boundary([14,20,0,1.4,20/14,9])})
+#domain.set_boundary({'exterior': Dirichlet_boundary([14,20,0,1.4,20/14,9])})
+domain.set_boundary({'exterior': Reflective_boundary(domain)})
 domain.order = 2
 domain.set_timestepping_method('rk2')
@@ -72,4 +76,9 @@
 t0 = time.time()
 
+finaltime= 0.0
+
+#===================================================================
+# Time loop
+#===================================================================
 for t in domain.evolve(yieldstep = yieldstep, finaltime = finaltime):
     domain.write_time()
@@ -84,6 +93,8 @@
 VelocityQ = domain.quantities['velocity'].vertex_values
 x = X.flat
-z = domain.quantities['elevation'].vertex_values.flat
-stage=HeightQ.flat+z
+z = domain.quantities['elevation'].vertex_values
+stage=HeightQ+z
+stage = stage.flat
+z = z.flat
 
 from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sww/run_dry_dam.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sww/run_dry_dam.py	(revision 8203)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sww/run_dry_dam.py	(revision 8204)
@@ -81,5 +81,5 @@
 k = 0
 
-N = 10000
+N = 2000
 print "Evaluating domain with %d cells" %N
 domain = Domain(*uniform_mesh(N,x_1=L))
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sww/sww_domain.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sww/sww_domain.py	(revision 8203)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sww/sww_domain.py	(revision 8204)
@@ -235,5 +235,8 @@
 	
     #Calculate height (and fix negatives)better be non-negative!
+    w_C[:] = numpy.maximum(w_C, z_C)
     h_C[:] = w_C - z_C
+
+
     u_C[:]  = uh_C/(h_C + h0/h_C)
 
@@ -282,9 +285,9 @@
     #print 'any' ,numpy.any( h_V[:,1] < 0.0)
 
-    h00 = 1e-12
+    #h00 = 1e-12
     #print h00
 
-    h_V[:,:] = numpy.where (h_V <= h00, 0.0, h_V)
-    u_V[:,:] = numpy.where (h_V <= h00, 0.0, u_V)
+    #h_V[:,:] = numpy.where (h_V <= h00, 0.0, h_V)
+    #u_V[:,:] = numpy.where (h_V <= h00, 0.0, u_V)
 
 #    # protect from edge values going negative