Index: /trunk/anuga_core/source/anuga_parallel/test_all.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/test_all.py	(revision 8262)
+++ /trunk/anuga_core/source/anuga_parallel/test_all.py	(revision 8263)
@@ -20,5 +20,4 @@
 #List files that should be excluded from the testing process.
 #E.g. if they are known to fail and under development
-exclude_files = ['test_failure.py']
 
 # Directories that should not be searched for test files.
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/base/generic_domain.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/base/generic_domain.py	(revision 8262)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/base/generic_domain.py	(revision 8263)
@@ -1395,25 +1395,25 @@
 
 
-        Stage      = self.quantities['stage']
-        Xmom       = self.quantities['xmomentum']
-        Bed        = self.quantities['elevation']
-        Height     = self.quantities['height']
-        Velocity   = self.quantities['velocity']
-
-        #Arrays
-        w_C   = Stage.centroid_values
-        uh_C  = Xmom.centroid_values
-        z_C   = Bed.centroid_values
-        h_C   = Height.centroid_values
-        u_C   = Velocity.centroid_values
-
-        import numpy as np
-        print '== before forcing ======='
-        print 'w_C', np.any(np.isnan(w_C))
-        print 'uh_C', np.any(np.isnan(uh_C))
-        print 'z_C', np.any(np.isnan(z_C))
-        print 'h_C', np.any(np.isnan(h_C))
-        print 'u_C', np.any(np.isnan(u_C))
-        print 'w_ex_update', np.any(np.isnan(Stage.explicit_update))
+#        Stage      = self.quantities['stage']
+#        Xmom       = self.quantities['xmomentum']
+#        Bed        = self.quantities['elevation']
+#        Height     = self.quantities['height']
+#        Velocity   = self.quantities['velocity']
+#
+#        #Arrays
+#        w_C   = Stage.centroid_values
+#        uh_C  = Xmom.centroid_values
+#        z_C   = Bed.centroid_values
+#        h_C   = Height.centroid_values
+#        u_C   = Velocity.centroid_values
+#
+#        import numpy as np
+#        print '== before forcing ======='
+#        print 'w_C', np.any(np.isnan(w_C))
+#        print 'uh_C', np.any(np.isnan(uh_C))
+#        print 'z_C', np.any(np.isnan(z_C))
+#        print 'h_C', np.any(np.isnan(h_C))
+#        print 'u_C', np.any(np.isnan(u_C))
+#        print 'w_ex_update', np.any(np.isnan(Stage.explicit_update))
 
         timestep = self.timestep
@@ -1424,11 +1424,11 @@
         self.compute_forcing_terms()
 
-        print '==after forcing ======='
-        print 'w_C', np.any(np.isnan(w_C))
-        print 'uh_C', np.any(np.isnan(uh_C))
-        print 'z_C', np.any(np.isnan(z_C))
-        print 'h_C', np.any(np.isnan(h_C))
-        print 'u_C', np.any(np.isnan(u_C))
-        print 'w_ex_update', np.any(np.isnan(Stage.explicit_update))
+#        print '==after forcing ======='
+#        print 'w_C', np.any(np.isnan(w_C))
+#        print 'uh_C', np.any(np.isnan(uh_C))
+#        print 'z_C', np.any(np.isnan(z_C))
+#        print 'h_C', np.any(np.isnan(h_C))
+#        print 'u_C', np.any(np.isnan(u_C))
+#        print 'w_ex_update', np.any(np.isnan(Stage.explicit_update))
 
         #Update conserved_quantities
@@ -1437,11 +1437,11 @@
             Q.update(timestep)
 
-        print '==after quantity update  ======='
-        print 'w_C', np.any(np.isnan(w_C))
-        print 'uh_C', np.any(np.isnan(uh_C))
-        print 'z_C', np.any(np.isnan(z_C))
-        print 'h_C', np.any(np.isnan(h_C))
-        print 'u_C', np.any(np.isnan(u_C))
-        print 'w_ex_update', np.any(np.isnan(Stage.explicit_update))
+#        print '==after quantity update  ======='
+#        print 'w_C', np.any(np.isnan(w_C))
+#        print 'uh_C', np.any(np.isnan(uh_C))
+#        print 'z_C', np.any(np.isnan(z_C))
+#        print 'h_C', np.any(np.isnan(h_C))
+#        print 'u_C', np.any(np.isnan(u_C))
+#        print 'w_ex_update', np.any(np.isnan(Stage.explicit_update))
 
 if __name__ == "__main__":
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/parabolic_canal.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/parabolic_canal.py	(revision 8262)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/parabolic_canal.py	(revision 8263)
@@ -69,5 +69,5 @@
     N = 100
     print "Evaluating domain with %d cells" %N
-    domain = dom.Domain(*uniform_mesh(N, x_0 = -2.0*L_x, x_1 = 2.0*L_x), bulk_modulus = 75.0)
+    domain = dom.Domain(*uniform_mesh(N, x_0 = -2.0*L_x, x_1 = 2.0*L_x), bulk_modulus = 100.0)
 
     domain.set_spatial_order(2)
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_domain.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_domain.py	(revision 8262)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_domain.py	(revision 8263)
@@ -170,5 +170,5 @@
 
         self.state = new_state
-        #self.state = numpy.where(h>=t, 1, 0)
+        self.state = numpy.where(h>=t, 1, 0)
 
     def distribute_to_vertices_and_edges(self):
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/test_sqpipe_domain.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/test_sqpipe_domain.py	(revision 8262)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/test_sqpipe_domain.py	(revision 8263)
@@ -6,5 +6,5 @@
 domain = anuga_1d.sqpipe.parabolic_canal.get_domain(dom)
 finaltime = 10000.0
-yieldstep = 50.0
+yieldstep = 10.0
 anuga_1d.sqpipe.parabolic_canal.animate_domain(domain, yieldstep, finaltime)
 anuga_1d.sqpipe.parabolic_canal.plot_domain(domain)